/**
 * \mainpage %Game Develop JS Platform
 * \image html gdlogo.png
 * \section welcome Welcome
 * This is the help file for the Game Develop JS Platform, which contains a reference of all the features provided
 * by the JS Platform and explains how to create <b>extensions</b> for this platform.<br>
 * Writing extensions requires to know Javascript and you need to write a bit of C++ code: Do not worry, everything is explained
 * here.
 *
 * ### Game engine documentation
 * Note that the documentation of the Javascript game engine of this platform is available [here](../GDJS Runtime Documentation/index.html).
 *
 * \section gettingstarted Getting started
 * Please refer to the getting started guide in the [GDCore documentation](..\GDCore Documentation\index.html).<br>
 * You can then read the \subpage OverviewOfGDJS.
 */

/**
 * \page OverviewOfGDJS Overview of the JS Platform
 *
 * The JS platform is composed of two parts:
 * - The first one is the *C++ part* exposing the platform to the IDE (and this is its documentation).
 * - The second part is the *Javascript game engine* which is in the *GDJS/Runtime* directory.
 *
 * You can read the documentation of the *Javascript game engine* [here](../GDJS Runtime Documentation/index.html).
 */